<template>
  <div>
    <div v-if="loading">Load data to view analysis</div>
    <template v-else>
      <div class="row">
        <div class="col">
          <BarEChart :barData="barData(filteredAdoption, criteriaKeys)" name="Complete adoption percentage" />
        </div>
        <div class="col">
          <form>
            <div class="form-row">
              <template v-for="crit in criteriaKeys">
                <div class="form-group col-md-2 mx-2">
                  <PieEChart :pieData="pieData(filteredAdoption, crit)" :name="criteria[crit]['name']"/>
                  <multiselect
                    v-model="selectedCriteria[crit]"
                    :searchable="false"
                    :close-on-select="true"
                    :options='[
                      "True", "False"
                    ]'
                    :show-labels="false"
                    :allow-empty="true"
                    :placeholder="criteria[crit]['name']"
                  />
                </div>
              </template>
            </div>
          </form>
        </div>
      </div>
      <div class="row">
        <div class="col">
          <LineEChart :lineData="lineData(filteredAdoption, criteria)" name="Project Adoption Timeline" :criteria="criteria"/>
        </div>
      </div>


      <form>
        <div class="form-row">
          <div class="form-group col-md-2">
            <label>Project</label>
            <multiselect
              v-model="selectedProjects"
              :options="allProjects"
              :multiple="true"
              :show-labels="false"
              placeholder="Select a project"
            />
          </div>
          <div class="form-group col-md-2">
            <label>Group</label>
            <multiselect
              v-model="selectedGroups"
              :options="allGroups"
              :multiple="true"
              :show-labels="false"
              placeholder="Select a group"
            />
          </div>
          
        </div>
      </form>
      <paginated-table
        :items="filteredAdoption"
        :total-items="filteredAdoption.length"
        :per-page-default="100"
      >
        <template v-slot:header>
          <tr>
            <th>Name</th>
            <th>Group</th>
            <th v-for="item in criteriaHeadings">
              {{ item }}
            </th>
          </tr>
        </template>
        <template v-slot:row="{ item: adoptionFinding }">
          <td><a :href="adoptionFinding.url" target="_blank" rel="noopener noreferrer">{{ adoptionFinding.name }}</a></td>
          <td><a :href="groupLink(adoptionFinding)" target="_blank" rel="noopener noreferrer">{{ adoptionFinding.group }}</a></td>
          <template v-for="crit in criteriaKeys">
            <td :class="adoptionClass(adoptionFinding, crit)">
                {{ renderAdoption(adoptionFinding, crit) }}
            </td>
          </template>
        </template>
      </paginated-table>
    </template>
  </div>
</template>
<script>
import PaginatedTable from "./components/paginated-table.vue";
import Multiselect from "vue-multiselect";
import PieEChart from "./components/pie-echart.vue";
import BarEChart from "./components/bar-echart.vue";
import LineEChart from "./components/line-echart.vue";

function computeGroupAdoption(findings, criteria) {
  var groupAdoption = {}
  for(var finding of findings) {
    var finding_adoption = 0
    for(var crit of criteria) {
      if(finding[crit] === 1) {
        finding_adoption ++
      }
    }
    if(finding.group in groupAdoption) {
      groupAdoption[finding.group]["total"] += criteria.length
      groupAdoption[finding.group]["adoption"] += finding_adoption
    } else {
      groupAdoption[finding.group] = {"total": criteria.length, "adoption":finding_adoption}
    }
  }
  for (let [group, value] of Object.entries(groupAdoption)) {
    for (let [other_group, other_value] of Object.entries(groupAdoption)) {
      if (group != other_group && other_group.includes(group)) {
        groupAdoption[group]["total"] += groupAdoption[other_group]["total"]
        groupAdoption[group]["adoption"] += groupAdoption[other_group]["adoption"]
      }
    }
  }
  return groupAdoption
}

function computePieAdoption(findings, criterium) {
  var findingAdoption = {"True":0, "False":0}
  for(var finding of findings) {
    if(finding[criterium] === 1) {
      findingAdoption["True"] ++
    } else {
      findingAdoption["False"] ++
    }
  }
  return findingAdoption
}

function flattenSeries(timeseries) {
  const orderedTimeseries = Object.keys(timeseries).sort().reduce(
    (obj, key) => { 
    obj[key] = timeseries[key]; 
    return obj;
  }, {});
  var dates = Object.keys(orderedTimeseries)
  var critSeries = {}
  for(var date in orderedTimeseries) {
    for(var crit in orderedTimeseries[date]) {
      if(crit in critSeries) {
        critSeries[crit].push(orderedTimeseries[date][crit])
      } else {
        critSeries[crit] = [orderedTimeseries[date][crit]]
      }
    }
  }

  var dataset = []
  for(var crit in critSeries) {
    var series = {
      name: crit,
      type: 'line',
      data: critSeries[crit]
    }
    dataset.push(series)
  }
  return {"dates" : dates, "series": dataset}
}

export default {
  components: {
    PaginatedTable,
    Multiselect,
    PieEChart,
    BarEChart,
    LineEChart
  },
  data() {
    return {
      loading: true,
      adoptionData: [],
      criteria: {},
      metaData: {},
      lastCrawlDate: "",
      projectData: {},
      selectedGroups: [],
      selectedProjects: [],
      selectedCriteria: {},
      adoptedGroups: 0
    };
  },
  async mounted() {
    const adoptionResponse = await fetch("./adoption_data.json");
    this.adoptionData = await adoptionResponse.json();
    const criteriaResponse = await fetch("./adoption_criteria.json");
    this.criteria = await criteriaResponse.json();
    //add ci as default criterium
    this.criteria["has_ci"] = {"name":"CI configured"}

    for(var finding of this.adoptionData) {
      if(finding.path in this.projectData) {
        this.projectData[finding.path].push(finding)
      } else {
        this.projectData[finding.path]= [finding]
      }
      if(finding.date > this.lastCrawlDate) {
        this.lastCrawlDate = finding.date
      }
    }
    this.loading = false;
  },
  methods: {
    groupLink(finding) {
      var projectLink = finding.url
      const projectGroup = finding.group
      return projectLink.substring(0,projectLink.indexOf(projectGroup)+projectGroup.length)
    },
    renderAdoption(adoptionFinding, crit) {
      const adoptionValue = adoptionFinding[crit]
      if(adoptionValue == 1) {
        return "True"
      }
      return "False"
    },
    adoptionClass(adoptionFinding, crit) {
      const adoptionValue = adoptionFinding[crit]
      if(adoptionValue == 1) {
        return "adopted"
      }
      return "notAdopted"
    },
    barData(filteredAdoption, criteriaKeys) {
      var groupAdoption = computeGroupAdoption(filteredAdoption, criteriaKeys)
      var groupData = []
      var labels = []
      var data = []
      for(var group in groupAdoption) {
        const adoptionPercentage = groupAdoption[group]["adoption"] / groupAdoption[group]["total"] * 100
        if(adoptionPercentage === 0) {
          continue
        }
        groupData.push([group,adoptionPercentage])
      }
      this.adoptedGroups = groupData.length
      var sorted = groupData.sort((a, b) => a[1] - b[1]);
      var colors = sorted.map(function(e) {
        if(e[1] > 0 && e[1] < 25) {
          e.push("#bf212f")
        } else if(e[1] > 20 && e[1] < 75) {
          e.push("#f9a73e")
        } else {
          e.push("#27b376")
        }
      })
      return sorted
    },
    pieData(filteredAdoption, criterium) {
      var pieAdoption = computePieAdoption(filteredAdoption, criterium)
      var pieData = []
      for(var pieSeries in pieAdoption) {
        const color = pieSeries === "True" ? "#27b376" : "#bf212f"
        pieData.push({
          value: pieAdoption[pieSeries],
          name: pieSeries,
          itemStyle: {
            color: color
          }
        })
      }
      return pieData
    },

    // for all filtered projects, pull other data points and sum the criteria for each point in time
    // generates an object of the form {"22-01-02": { "sast": 0,"dast":0, }

    lineData(filteredAdoption, criteria) {
      var timeseries = {}
      for(var project of filteredAdoption) {

        //pull all data points for filtered project (multiple time entries)
        if(project.path in this.projectData) {

          // iterate over time entries of projects
          for(var projectAtDate of this.projectData[project.path]) {

            if(!(projectAtDate.date in timeseries)) {
              timeseries[projectAtDate.date] = {}
            }

            //for all adoption criteria
            for(var critKey of Object.keys(criteria)) {
              const criterium = criteria[critKey]
              // use names for the series, but look for keys in the project data
              if(criterium.name in timeseries[projectAtDate.date]) {
                timeseries[projectAtDate.date][criterium.name] += projectAtDate[critKey]
              } else {
                timeseries[projectAtDate.date][criterium.name] = projectAtDate[critKey]
              }
            }
          }
        }
      }

      return flattenSeries(timeseries)
    }
  },
  computed: {
    allGroups() {
      var groupArray = Object.values(this.adoptionData).map((finding) => finding.group).flat()
      return Array.from(new Set(groupArray)).filter(Boolean).sort();
    },
    allProjects() {
      var projectArray = Object.values(this.adoptionData).map((finding) => finding.name).flat()
      return Array.from(new Set(projectArray)).filter(Boolean).sort();
    },
    filteredAdoption() {
      var filteredFindings = Object.values(this.adoptionData)
        .filter((finding) => {
          let visible = true;
          if (visible && finding.date != this.lastCrawlDate) {
            visible = visible && false
          }
          if (visible && this.selectedGroups.length) {
            visible =
              visible && this.selectedGroups.includes(finding.group || null);
          }
          if (visible && this.selectedProjects.length) {
            visible =
              visible && this.selectedProjects.includes(finding.name || null);
          }
          let keys = Object.keys(this.selectedCriteria);
          if (visible && keys.length) {

            for(var key of keys) {
              const findingValue = finding[key] === 1 ? "True" : "False" 
              if(this.selectedCriteria[key] === findingValue || this.selectedCriteria[key] == null) {
                visible = visible && true
              } else {
                visible = visible && false
              }
            }
          }
          return visible;
        });
      if(filteredFindings.length == 0) {
        console.log("All values filtered!")
      }
      return filteredFindings
    },
    criteriaHeadings() {
      var headings = []
      for(const criterium in this.criteria) {
        headings.push(this.criteria[criterium].name)
      }
      return headings
    },
    criteriaKeys() {
      return Object.keys(this.criteria)
    }
  },
};
</script>
<style>
  .adopted {
    background-color: #d4edda;
  }
  .notAdopted {
    background-color: #f8d7da;
  }
  .multiselect__content-wrapper /*, .multiselect__element */ {
   width: fit-content; 
  }

</style>